/*
 *  Sphere.cpp - 	 Sphere effect
 *               Written by Tinic Urou
 *               Public domain
 */

#include <AppKit.h>
#include <InterfaceKit.h>
#include <KernelKit.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


// Types
typedef unsigned char 	UBYTE;
typedef unsigned short 	UWORD;
typedef unsigned long 	ULONG;
typedef char 			BYTE;
typedef short 			WORD;
typedef long 			LONG;

// Constants

const 	ULONG 			APP_SIGNATURE = '????';
const 	LONG 			DISPLAY_X = 320;
const 	LONG 			DISPLAY_Y = 200;
const 	LONG 			PICTURE_X = 0x160;
const 	LONG 			PICTURE_Y = 0x149;

// Globals

		BBitmap			*my_bitmap;
		uchar			colors[256],*bits;
extern	uchar			pic[];

// Window/Application messages

const 	LONG			MSG_REDRAW = 1;

class 					SphereWindow;

// Application object
class Sphere : public BApplication 
{
	public:
						Sphere();
			void 		ReadyToRun(void);
			bool 		QuitRequested(void);
			void 		AboutRequested(void);

	private:
	
			SphereWindow 	*the_window;
			BBitmap 	*the_bitmap;
};

// Window object
class SphereWindow : public BWindow 
{
	public:
	
						SphereWindow(short width, short height, BBitmap *bitmap);
			bool 		QuitRequested(void);
			void 		MessageReceived(BMessage *msg);

	private:
	
			void		recalc(void);

			BBitmap 	*the_bitmap;
			BView		*main_view;	
			ULONG		xmod;
};

unsigned int star[101][3]= { 300,84,0, 227,129,0, 101,34,0, 275,56,0, 217,37,0, 
134,155,0, 112,195,0, 277,18,0, 143,99,0, 149,161,0, 49,172,0, 
98,64,0, 95,83,0, 250,99,0, 59,80,0, 249,21,0, 58,141,0, 
76,161,0, 306,173,0, 112,32,0, 293,174,0, 31,79,0, 248,172,0, 
104,64,0, 229,74,0, 38,46,0, 41,20,0, 209,34,0, 126,188,0, 
84,62,0, 213,53,0, 304,179,0, 49,10,0, 10,104,0, 264,9,0, 
51,29,0, 14,91,0, 139,123,0, 27,54,0, 263,23,0, 319,183,0, 
187,66,0, 261,31,0, 314,140,0, 168,4,0, 289,119,0, 259,140,0, 
228,154,0, 8,25,0, 309,182,0, 117,40,0, 87,126,0, 226,86,0, 
310,162,0, 19,176,0, 280,105,0, 52,39,0, 259,97,0, 35,132,0, 
33,63,0, 174,6,0, 262,98,0, 115,7,0, 294,58,0, 117,76,0, 
24,124,0, 295,19,0, 107,11,0, 306,15,0, 126,177,0, 130,132,0, 
216,121,0, 157,9,0, 291,122,0, 257,105,0, 157,95,0, 224,27,0, 
90,133,0, 309,175,0, 26,5,0, 53,9,0, 173,167,0, 238,157,0, 
207,176,0, 80,88,0, 181,56,0, 232,169,0, 19,93,0, 214,19,0, 
46,31,0, 194,186,0, 89,131,0, 212,55,0, 231,66,0, 59,21,0, 
119,119,0, 259,29,0, 228,53,0, 317,119,0, 52,121,0, 146,71,0 };

#define ScreenWidth 320    /* Width of Mode 13h */
#define ScreenHeight 200   /* Height of Mode 13h */

#define VLevel1	1
#define VLevel2 2
#define VLevel3 3
#define VLevel4 4

/* we have four levels of stars, and they all go a different speed, here we
use defines for the various speeds.  This is what you would change to speed
up the stars, believe me, this program will fly :)  These look the best to me
though */

#define XPos 	0
#define YPos	1
#define Old_Pos	2

void display_stars(void); /* Prototyping is wonderful :) */

unsigned int *YPosChart; /* Pointer to the look-up chart, see below */

void display_stars(void)
{
	int star_ref=0; /* Which star out of the 120 that we are on */

	unsigned int ypost; /* for the Ypostion calculations */

	/* Okay, I converted this from Dreaden's code, and he did 4 loops,
	and I figured, what the hell, might as well.  I will explain the 1st
	loop, and the rest are the same, exactly the same, with one thing
	that changes from loop to loop */

	for(star_ref=0;star_ref<40;star_ref++) /* 4th level, do 40 stars */
	{
		*((bits)+star[star_ref][Old_Pos])=0;
		ypost=star[star_ref][YPos];
		ypost=YPosChart[ypost];
		star[star_ref][XPos]+=VLevel1;
		if(star[star_ref][XPos] > ScreenWidth) star[star_ref][XPos]-=ScreenWidth;
		ypost+=star[star_ref][XPos];
		*((bits)+ypost)=index_for_color(128,128,128);
		star[star_ref][Old_Pos]=ypost;
	}

	for(star_ref=40;star_ref<70;star_ref++) /*Third level, thirty stars */
	{
		*((bits)+star[star_ref][Old_Pos])=0;
		ypost=star[star_ref][YPos];
		ypost=YPosChart[ypost];
		star[star_ref][XPos]+=VLevel2; 

		if(star[star_ref][XPos] > ScreenWidth) star[star_ref][XPos]-=ScreenWidth;

		ypost+=star[star_ref][XPos];
		*((bits)+ypost)=index_for_color(176,176,176); 

		star[star_ref][Old_Pos]=ypost;
	}
	for(star_ref=70;star_ref<90;star_ref++) /* Second level, 20 stars */
	{
		*((bits)+star[star_ref][Old_Pos])=0;
		ypost=star[star_ref][YPos];
		ypost=YPosChart[ypost];

		star[star_ref][XPos]+=VLevel3; 

		if(star[star_ref][XPos] > ScreenWidth) star[star_ref][XPos]-=ScreenWidth;

		ypost+=star[star_ref][XPos];
		*((bits)+ypost)=index_for_color(211,211,211); 

		star[star_ref][Old_Pos]=ypost;
	}
	for(star_ref=90;star_ref<101;star_ref++) /* First level, 10 stars */
	{
		*((bits)+star[star_ref][Old_Pos])=0;
		ypost=star[star_ref][YPos];
		ypost=YPosChart[ypost];

		star[star_ref][XPos]+=VLevel4; 

		if(star[star_ref][XPos] > ScreenWidth) star[star_ref][XPos]-=ScreenWidth;

		ypost+=star[star_ref][XPos];
		*((bits)+ypost)=index_for_color(255,255,255);

		star[star_ref][Old_Pos]=ypost;
	}

}
	
int rot;
char k;

char *bm;

int R;		//Radius of sphere
int D;		//Diameter of sphere
int C;		//Circum of sphere
int* Rh;	//Rad at height

int W;		//Width of bm
int H;		//Height of bm

int** TRF;	//Horizontal transformations
int* TRFV;	//Vertical (scan line) transformations

// Create application object and start it
short main(short argc, char **argv)
{	
	Sphere *the_app;

	srand(system_time());

	the_app = new Sphere();
	the_app->Run();
	delete the_app;

	return 0;
}


/*
 *  Application constructor
 */

Sphere::Sphere() : BApplication(APP_SIGNATURE)
{
	the_window = NULL;
	the_bitmap = NULL;
}

/*
 *	Thats from me!
 */

void Sphere::AboutRequested(void) 
{
	char str[256];
	sprintf(str, "Sphere by Tinic Urou\n<5uro@informatik.uni-hamburg.de>\nFreely distributable.");
	BAlert *the_alert = new BAlert("", str, "OK");
	the_alert->Go();
}


/*
 *  Open window and start rendering
 */

void Sphere::ReadyToRun(void)
{
	// Allocate the bitmap		
	my_bitmap = the_bitmap = new BBitmap(BRect(0, 0, DISPLAY_X-1, DISPLAY_Y-1), B_COLOR_8_BIT);
	bits=(uchar *)the_bitmap->Bits();

 
 	bm=(char *)pic;
	W=PICTURE_X;
	H=PICTURE_Y;

 	C=W;

 	D=(float)(DISPLAY_Y-20);
	R=(float)(DISPLAY_Y-20)/2;

 	register int i,j;

 	Rh=new int[D];
 	for(i=0;i<D;i++) Rh[i]=sqrt(R*R-(R-i)*(R-i));

 	TRF=new int*[D];
 	for(i=0;i<D;i++) TRF[i]=new int[Rh[i]];

 	for(i=0;i<D;i++)
	{
		for(j=0;j<Rh[i];j++) 
		{
			double theta=asin((float)j/(float)Rh[i]);
			float arc=(float)C/4.0;
			float fractional=theta/(M_PI/2.0);
			int offset=fractional*arc;
			TRF[i][j]=offset; 
		}
	}

 	TRFV=new int[D];

 	for(i=0;i<D;i++) 
	{
		float dh=(float)H/(float)D;
		int line=(float)i*dh;
		TRFV[i]=W*line; 
	}
	
	YPosChart=(unsigned int *)malloc(ScreenHeight*sizeof(unsigned int));
	for(int x=0;x<ScreenHeight;x++)YPosChart[x]=x*ScreenWidth;


	// Open window
	the_window = new SphereWindow(DISPLAY_X, DISPLAY_Y, the_bitmap);

	// Start action
	the_window->PostMessage(MSG_REDRAW);

	// Let it flow from the orginal to the distorted look
}


/*
 *  Quit requested (either by menu or by closing the window)
 */

bool Sphere::QuitRequested(void)
{
	// Make sure that the window closes first
	if (BApplication::QuitRequested()) 
	{	
		free(YPosChart);
		if (the_bitmap)	delete the_bitmap;
		return TRUE;
	}
	return FALSE;
}


/*
 *  Window constructor
 */

SphereWindow::SphereWindow(short width, short height, BBitmap *bitmap) : BWindow(BRect(0, 0, width-1, height-1), "Sphere by Tinic", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	the_bitmap = bitmap;
	
	xmod = bitmap->BytesPerRow();
	
	// Move window to right position
	MoveTo(80, 60);

	// Create bitmap view
	Lock();
	main_view = new BView(BRect(0, 0, DISPLAY_X-1, DISPLAY_Y-1),"", B_FOLLOW_NONE,NULL);
	AddChild(main_view);
	Unlock();

	// Show the window
	Show();
}


/*
 *  Closing the window quits the program
 */

bool SphereWindow::QuitRequested(void)
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return TRUE;
}


/*
 *  Handles redraw messages
 */

void SphereWindow::MessageReceived(BMessage *msg)
{
	switch (msg->what) {
		case MSG_REDRAW:  // Redraw bitmap
			Lock();
			main_view->DrawBitmapAsync(the_bitmap);
			recalc();
			main_view->Sync();
			PostMessage(MSG_REDRAW);
			Unlock();
			break;
		default:
			BWindow::MessageReceived(msg);
	}
}


/*
 *  Main calculation
 */

void SphereWindow::recalc(void)
{
	UBYTE 	*q=(UBYTE *)the_bitmap->Bits();	
	int x=160;
	
	memset(bits,0,DISPLAY_X*DISPLAY_Y);

	display_stars();  
	
	rot+=2;
	rot%=W;
	for(int i=0;i<D;i++) 
	{
		char *loc=bm+TRFV[i]+rot;
		int i320=(i+10)*320;
		for(int j=0;j<Rh[i];j++) 
		{
			int h_offset=TRF[i][j];
			char c1=*(loc+h_offset);
			char c2=*(loc-h_offset);
			q[x+j+i320]=c1;
			q[x-j+i320]=c2;
		}
	}

}

